<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>json</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <p>
      JSON is an extremely simple data-interchange format. As
      <a href="https://json.org">json.org</a> says, it is easy for humans to
      read and write and for machines to parse and generate.
    </p>
    <p>A piece of JSON must represent either:</p>
    <ul>
      <li>
        A collection of name/value pairs (<code>{ }</code>). In various
        languages, this is realized as an object, record, struct, dictionary,
        hash table, keyed list, or associative array.
      </li>
      <li>
        An ordered list of values (<code>[ ]</code>). In various languages, this
        is realized as an array, vector, list, or sequence.
      </li>
    </ul>
    <p>
      JSON in its purest form has no actual comments, but most parsers will
      accept C-style (<code>//</code>, <code>/* */</code>) comments. Some
      parsers also tolerate a trailing comma (i.e. a comma after the last
      element of an array or the after the last property of an object), but they
      should be avoided for better compatibility.
    </p>
    <p>
      For the purposes of this tutorial, everything is going to be 100% valid
      JSON. Luckily, it kind of speaks for itself.
    </p>
    <p>Supported data types:</p>
    <ul>
      <li>
        Strings: <code>"hello"</code>, <code>"\"A quote.\""</code>,
        <code>"\u0abe"</code>, <code>"Newline.\n"</code>
      </li>
      <li>
        Numbers: <code>23</code>, <code>0.11</code>, <code>12e10</code>,
        <code>3.141e-10</code>, <code>1.23e+4</code>
      </li>
      <li>Objects: <code>{ "key": "value" }</code></li>
      <li>Arrays: <code>["Values"]</code></li>
      <li>
        Miscellaneous: <code>true</code>, <code>false</code>, <code>null</code>
      </li>
    </ul>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode json"
      ><code class="sourceCode json"><a class="sourceLine" id="cb1-1" title="1"><span class="fu">{</span></a>
<a class="sourceLine" id="cb1-2" title="2">  <span class="dt">&quot;key&quot;</span><span class="fu">:</span> <span class="st">&quot;value&quot;</span><span class="fu">,</span></a>
<a class="sourceLine" id="cb1-3" title="3"></a>
<a class="sourceLine" id="cb1-4" title="4">  <span class="dt">&quot;keys&quot;</span><span class="fu">:</span> <span class="st">&quot;must always be enclosed in double quotes&quot;</span><span class="fu">,</span></a>
<a class="sourceLine" id="cb1-5" title="5">  <span class="dt">&quot;numbers&quot;</span><span class="fu">:</span> <span class="dv">0</span><span class="fu">,</span></a>
<a class="sourceLine" id="cb1-6" title="6">  <span class="dt">&quot;strings&quot;</span><span class="fu">:</span> <span class="st">&quot;Hellø, wørld. All unicode is allowed, along with </span><span class="ch">\&quot;</span><span class="st">escaping</span><span class="ch">\&quot;</span><span class="st">.&quot;</span><span class="fu">,</span></a>
<a class="sourceLine" id="cb1-7" title="7">  <span class="dt">&quot;has bools?&quot;</span><span class="fu">:</span> <span class="kw">true</span><span class="fu">,</span></a>
<a class="sourceLine" id="cb1-8" title="8">  <span class="dt">&quot;nothingness&quot;</span><span class="fu">:</span> <span class="kw">null</span><span class="fu">,</span></a>
<a class="sourceLine" id="cb1-9" title="9"></a>
<a class="sourceLine" id="cb1-10" title="10">  <span class="dt">&quot;big number&quot;</span><span class="fu">:</span> <span class="fl">1.2e100</span><span class="fu">,</span></a>
<a class="sourceLine" id="cb1-11" title="11"></a>
<a class="sourceLine" id="cb1-12" title="12">  <span class="dt">&quot;objects&quot;</span><span class="fu">:</span> <span class="fu">{</span></a>
<a class="sourceLine" id="cb1-13" title="13">    <span class="dt">&quot;comment&quot;</span><span class="fu">:</span> <span class="st">&quot;Most of your structure will come from objects.&quot;</span><span class="fu">,</span></a>
<a class="sourceLine" id="cb1-14" title="14"></a>
<a class="sourceLine" id="cb1-15" title="15">    <span class="dt">&quot;array&quot;</span><span class="fu">:</span> <span class="ot">[</span><span class="dv">0</span><span class="ot">,</span> <span class="dv">1</span><span class="ot">,</span> <span class="dv">2</span><span class="ot">,</span> <span class="dv">3</span><span class="ot">,</span> <span class="st">&quot;Arrays can have anything in them.&quot;</span><span class="ot">,</span> <span class="dv">5</span><span class="ot">]</span><span class="fu">,</span></a>
<a class="sourceLine" id="cb1-16" title="16"></a>
<a class="sourceLine" id="cb1-17" title="17">    <span class="dt">&quot;another object&quot;</span><span class="fu">:</span> <span class="fu">{</span></a>
<a class="sourceLine" id="cb1-18" title="18">      <span class="dt">&quot;comment&quot;</span><span class="fu">:</span> <span class="st">&quot;These things can be nested, very useful.&quot;</span></a>
<a class="sourceLine" id="cb1-19" title="19">    <span class="fu">}</span></a>
<a class="sourceLine" id="cb1-20" title="20">  <span class="fu">},</span></a>
<a class="sourceLine" id="cb1-21" title="21"></a>
<a class="sourceLine" id="cb1-22" title="22">  <span class="dt">&quot;silliness&quot;</span><span class="fu">:</span> <span class="ot">[</span></a>
<a class="sourceLine" id="cb1-23" title="23">    <span class="fu">{</span></a>
<a class="sourceLine" id="cb1-24" title="24">      <span class="dt">&quot;sources of potassium&quot;</span><span class="fu">:</span> <span class="ot">[</span><span class="st">&quot;bananas&quot;</span><span class="ot">]</span></a>
<a class="sourceLine" id="cb1-25" title="25">    <span class="fu">}</span><span class="ot">,</span></a>
<a class="sourceLine" id="cb1-26" title="26">    <span class="ot">[</span></a>
<a class="sourceLine" id="cb1-27" title="27">      <span class="ot">[</span><span class="dv">1</span><span class="ot">,</span> <span class="dv">0</span><span class="ot">,</span> <span class="dv">0</span><span class="ot">,</span> <span class="dv">0</span><span class="ot">],</span></a>
<a class="sourceLine" id="cb1-28" title="28">      <span class="ot">[</span><span class="dv">0</span><span class="ot">,</span> <span class="dv">1</span><span class="ot">,</span> <span class="dv">0</span><span class="ot">,</span> <span class="dv">0</span><span class="ot">],</span></a>
<a class="sourceLine" id="cb1-29" title="29">      <span class="ot">[</span><span class="dv">0</span><span class="ot">,</span> <span class="dv">0</span><span class="ot">,</span> <span class="dv">1</span><span class="ot">,</span> <span class="st">&quot;neo&quot;</span><span class="ot">],</span></a>
<a class="sourceLine" id="cb1-30" title="30">      <span class="ot">[</span><span class="dv">0</span><span class="ot">,</span> <span class="dv">0</span><span class="ot">,</span> <span class="dv">0</span><span class="ot">,</span> <span class="dv">1</span><span class="ot">]</span></a>
<a class="sourceLine" id="cb1-31" title="31">    <span class="ot">]</span></a>
<a class="sourceLine" id="cb1-32" title="32">  <span class="ot">]</span><span class="fu">,</span></a>
<a class="sourceLine" id="cb1-33" title="33"></a>
<a class="sourceLine" id="cb1-34" title="34">  <span class="dt">&quot;alternative style&quot;</span><span class="fu">:</span> <span class="fu">{</span></a>
<a class="sourceLine" id="cb1-35" title="35">    <span class="dt">&quot;comment&quot;</span><span class="fu">:</span> <span class="st">&quot;check this out!&quot;</span><span class="fu">,</span></a>
<a class="sourceLine" id="cb1-36" title="36">    <span class="dt">&quot;comma position&quot;</span><span class="fu">:</span> <span class="st">&quot;doesn&#39;t matter, if it&#39;s before the next key, it&#39;s valid&quot;</span><span class="fu">,</span></a>
<a class="sourceLine" id="cb1-37" title="37">    <span class="dt">&quot;another comment&quot;</span><span class="fu">:</span> <span class="st">&quot;how nice&quot;</span></a>
<a class="sourceLine" id="cb1-38" title="38">  <span class="fu">},</span></a>
<a class="sourceLine" id="cb1-39" title="39"></a>
<a class="sourceLine" id="cb1-40" title="40">  <span class="dt">&quot;whitespace&quot;</span><span class="fu">:</span> <span class="st">&quot;Does not matter.&quot;</span><span class="fu">,</span></a>
<a class="sourceLine" id="cb1-41" title="41"></a>
<a class="sourceLine" id="cb1-42" title="42">  <span class="dt">&quot;that was short&quot;</span><span class="fu">:</span> <span class="st">&quot;And done. You now know everything JSON has to offer.&quot;</span></a>
<a class="sourceLine" id="cb1-43" title="43"><span class="fu">}</span></a></code></pre>
    </div>
    <h2 id="further-reading">Further Reading</h2>
    <ul>
      <li>
        <a href="https://json.org">JSON.org</a> All of JSON beautifully
        explained using flowchart-like graphics.
      </li>
      <li>
        <a href="https://www.youtube.com/watch?v=wI1CWzNtE-M">JSON Tutorial</a>
        A concise introduction to JSON.
      </li>
    </ul>
  </body>
</html>
